/*
 * check_share 
 * 
 * @author     Alan Pipitone
 * @website    http://www.alan-pipitone.com
 * 
 */
package check_share;

//import packages for java embedded smb client
import jcifs.smb.*;
//import packages for calendar and date manipulation
import java.util.Calendar;
import java.text.SimpleDateFormat;
//import packages to check the arguments
import java.util.regex.Pattern;
import java.util.regex.Matcher;

public class Check_share {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)
    {

        
	try
        {
            //---------------------------------------------------------------------------------------------
            //                               INITIALIZE ALL VARIABLES
            //---------------------------------------------------------------------------------------------
            //count the arguments
            int countFileNameArgument = 0;
            int countRemoteShareArgument = 0;
            int countUserArgument = 0;
            int countPwdArgument = 0;
            int countDomainArgument = 0;
            int countRespTimeOutArgument = 0;
            int countSoTimeOutArgument = 0;
            int countWarningArgument = 0;
            int countCriticalArgument = 0;
            //index of arguments in the array args
            int indexFileNameArgument = 0;
            int indexRemoteShareArgument = 0;
            int indexUserArgument = 0;
            int indexPwdArgument = 0;
            int indexDomainArgument = 0;
            int indexRespTimeOutArgument = 0;
            int indexSoTimeOutArgument = 0;
            int indexWarningArgument = 0;
            int indexCriticalArgument = 0;
            //result of argument counters addition
            int addArgument=0; 
            //configuration strings for the smb client
            String remoteShare = "";
            String fileName = "";
            String userName = "";
            String password = "";
            String domain = "";
            String respTimeOut = "30000";  //default timeout  = 30 sec
            String soTimeOut = "35000";  //default timeout  = 35 sec
            //get current date
            Calendar cal = Calendar.getInstance();
            //format date string
            String DATE_FORMAT = "dd-MM-yyyy HH:mm:ss";
            SimpleDateFormat sDateFormat = new SimpleDateFormat(DATE_FORMAT);
            //compose the message (later we will write it into the remote file)
            String fileMessage = "Nagios check_share on " + sDateFormat.format(cal.getTime());
            //set variables for transfer time
            Long startTime_writeToShare;
            Long endTime_writeToShare;
            Long totalTime_writeToShare_TMP;
            Float totalTime_writeToShare;
            //critical and warning level
            Float warning = 2.0f;
            Float critical = 5.0f;

            //---------------------------------------------------------------------------------------------
            //                                    READ THE ARGUMENTS
            //---------------------------------------------------------------------------------------------
            //check the arguments so that their order doesn't matter
            for (int i=0; i<args.length; i++)
            {
                //arguments option
                Pattern pFileName = Pattern.compile("--filename=",Pattern.CASE_INSENSITIVE);
                Pattern pRemoteShare = Pattern.compile("--remoteshare=",Pattern.CASE_INSENSITIVE);
                Pattern pUserName = Pattern.compile("--username=",Pattern.CASE_INSENSITIVE);
                Pattern pPassword = Pattern.compile("--password=",Pattern.CASE_INSENSITIVE);
                Pattern pDomain = Pattern.compile("--domain=",Pattern.CASE_INSENSITIVE);
                Pattern pRespTimeOut = Pattern.compile("--resptimeout=",Pattern.CASE_INSENSITIVE);
                Pattern pSoTimeOut = Pattern.compile("--sotimeout=",Pattern.CASE_INSENSITIVE);
                Pattern pWarning = Pattern.compile("--warning=",Pattern.CASE_INSENSITIVE);
                Pattern pCritical = Pattern.compile("--critical=",Pattern.CASE_INSENSITIVE);
                
                //get the matcher objects
                Matcher mFileName = pFileName.matcher(args[i]);
                Matcher mRemoteShare = pRemoteShare.matcher(args[i]);
                Matcher mUserName = pUserName.matcher(args[i]);
                Matcher mPassword = pPassword.matcher(args[i]);
                Matcher mDomain = pDomain.matcher(args[i]);
                Matcher mRespTimeOut = pRespTimeOut.matcher(args[i]);
                Matcher mSoTimeOut = pSoTimeOut.matcher(args[i]);
                Matcher mWarning = pWarning.matcher(args[i]);
                Matcher mCritical = pCritical.matcher(args[i]);
                
                //looking for -filename argument
                while(mFileName.find())
                {
                    countFileNameArgument++;
                    indexFileNameArgument=i;
                }

                //looking for -remoteshare argument
                while(mRemoteShare.find())
                {
                    countRemoteShareArgument++;
                    indexRemoteShareArgument=i;
                }

                //looking for -username argument
                while(mUserName.find()) 
                {
                    countUserArgument++;
                    indexUserArgument=i;
                }
                
                //looking for -password argument
                while(mPassword.find()) 
                {
                    countPwdArgument++;
                    indexPwdArgument=i;
                }
                
                //looking for -domain argument
                while(mDomain.find()) 
                {
                    countDomainArgument++;
                    indexDomainArgument=i;
                }

                //looking for -resptimeout argument
                while(mRespTimeOut.find())
                {
                    countRespTimeOutArgument++;
                    indexRespTimeOutArgument=i;
                }
                
                //looking for -sotimeout argument
                while(mSoTimeOut.find())
                {
                    countSoTimeOutArgument++;
                    indexSoTimeOutArgument=i;
                }
                
                //looking for -warning argument
                while(mWarning.find())
                {
                    countWarningArgument++;
                    indexWarningArgument=i;
                }
                
                //looking for -warning argument
                while(mCritical.find())
                {
                    countCriticalArgument++;
                    indexCriticalArgument=i;
                }
            }
            
            //---------------------------------------------------------------------------------------------
            //                        CHECK IF THE ARGUMENTS ARE GOOD TO START THE TRANFER
            //---------------------------------------------------------------------------------------------
            //add counters arguments
            addArgument = countFileNameArgument + countRemoteShareArgument + countUserArgument + countPwdArgument + countDomainArgument + countRespTimeOutArgument + countSoTimeOutArgument + countWarningArgument + countCriticalArgument;
            
            //if all arguments are correctly set for the transfer file then start the transfer
            if(args.length == addArgument & countFileNameArgument==1 & countRemoteShareArgument==1 & countUserArgument==1 & countPwdArgument==1 & countDomainArgument==1 & (countRespTimeOutArgument==1|countRespTimeOutArgument==0) & (countSoTimeOutArgument==1|countSoTimeOutArgument==0) & (countWarningArgument==1 | countWarningArgument ==0) & (countCriticalArgument==1 | countCriticalArgument==0))
            {
                //---------------------------------------------------------------------------------------------
                //                        FILL VARIABLES WITH ARGS VALUES
                //---------------------------------------------------------------------------------------------
                fileName = args[indexFileNameArgument].replace("--filename=","");
                
                remoteShare = args[indexRemoteShareArgument].replace("--remoteshare=","");
                
                userName = args[indexUserArgument].replace("--username=","");
                password = args[indexPwdArgument].replace("--password=","");
                domain = args[indexDomainArgument].replace("--domain=","");
                
                //check if resp timeout is set (this is an optional argument)
                if(countRespTimeOutArgument==1)
                {
                    respTimeOut = args[indexRespTimeOutArgument].replace("--resptimeout=","");
                }
                
                //check if so timeout is set (this is an optional argument)
                if(countSoTimeOutArgument==1)
                {
                    soTimeOut = args[indexSoTimeOutArgument].replace("--sotimeout=","");
                }
                
                //---------------------------------------------------------------------------------------------
                //                         SET THE EMBEDDED SMB CLIENT PROPERTIES
                //---------------------------------------------------------------------------------------------
                jcifs.Config.setProperty("jcifs.smb.lmCompatitility","3");
                jcifs.Config.setProperty("jcifs.smb.client.username",userName);
                jcifs.Config.setProperty("jcifs.smb.client.password",password);
                jcifs.Config.setProperty("jcifs.smb.client.domain",domain);
                //jcifs.Config.setProperty("jcifs.util.loglevel","3");
                jcifs.Config.setProperty("jcifs.smb.client.responseTimeout",respTimeOut); //set timeout in millisecond
                jcifs.Config.setProperty("jcifs.smb.client.soTimeout",soTimeOut);

                
                //---------------------------------------------------------------------------------------------
                //                             WRITE REMOTE FILE INTO THE SHARE
                //---------------------------------------------------------------------------------------------
                //start time counter
                startTime_writeToShare = System.currentTimeMillis();
                //allocate new object for remote file
                SmbFile sFile = new SmbFile(remoteShare,fileName);
                //if the remote file already exist (for example by a previous check) we delete it
                if(sFile.exists()) sFile.delete();
                //create remote file
                sFile.createNewFile();
                //open an output stream to allow us to write into remote file
                SmbFileOutputStream sfos = new SmbFileOutputStream(sFile);
                //write into remote the message that we have prepared above
                sfos.write(fileMessage.getBytes());
                //close the output stream
                sfos.close();
                //delete file remote file
                SmbFile file = new SmbFile(remoteShare,fileName);
                file.delete();
                //calculate end time
                endTime_writeToShare = System.currentTimeMillis();
                //calculate total time in seconds
                totalTime_writeToShare_TMP = (endTime_writeToShare - startTime_writeToShare);
                totalTime_writeToShare = totalTime_writeToShare_TMP.floatValue()/1000;

                
                //---------------------------------------------------------------------------------------------
                //                                       PRINT OUTPUT
                //---------------------------------------------------------------------------------------------
                if(countWarningArgument==1 & countCriticalArgument == 1)
                {
                    //set the critical value
                    critical = new Float(args[indexCriticalArgument].replace("--critical=",""));
                    //set the warning value
                    warning = new Float(args[indexWarningArgument].replace("--warning=",""));
                }

                
                if(totalTime_writeToShare >= critical)
                {
                    //print the ok message with performance data
                    System.out.println("the transfer time has exceeded the critical threshold|time=" + totalTime_writeToShare.toString() + "s;" + warning + ";" + critical + ";;");
                    System.exit(2);
                }
                else if(totalTime_writeToShare >= warning)
                {
                    //print the ok message with performance data
                    System.out.println("the transfer time has exceeded the warning threshold|time=" + totalTime_writeToShare.toString() + "s;" + warning + ";" + critical + ";;");
                    System.exit(1);
                }
                else
                {
                    //print the ok message with performance data
                    System.out.println("OK: file successfully transferred|time=" + totalTime_writeToShare.toString() + "s;" + warning + ";" + critical + ";;" );
                }
                
            }
            else //if arguments aren't good then print the help
            {
                //---------------------------------------------------------------------------------------------
                //                                         PRINT HELP
                //---------------------------------------------------------------------------------------------
                String helpString = "\n\n";
                helpString = helpString + "Author: Alan Pipitone";
                helpString = helpString + "\n";
                helpString = helpString + "Website: http://www.alan-pipitone.com";
                helpString = helpString + "\n\n";
                helpString = helpString + "Invalid arguments. Help:";
                helpString = helpString + "\n\n";
                helpString = helpString + "This plug-in allows Nagios to check if a network share works well.";
                helpString = helpString + "\n\n";
                helpString = helpString + "How it works:";
                helpString = helpString + "\n\n";
                helpString = helpString + "This plug-in creates a text file into the remote share, writes a string with the current time into the file and then copies the text file from the remote share into the local folder (you can ";
                helpString = helpString + "choose which folder) of the Nagios server and finally it deletes the file from the remote share and from the Nagios server.";
                helpString = helpString + "\n";
                helpString = helpString + "If everything goes well the plug-in will return a message ok, otherwise it will return a message critical.";
                helpString = helpString + "\n";
                helpString = helpString + "It even returns the performance data.";
                helpString = helpString + "\n\n";
                helpString = helpString + "The plug-in works with java 7 or higher.";
                helpString = helpString + "\n\n";
                helpString = helpString + "Usage (the order of the arguments doesn't matter):";
                helpString = helpString + "\n\n";
                helpString = helpString + "java -jar check_share.jar --filename=<text file name> --remoteshare=<share smb url> --username=<username> --password=<password> --domain=<user domain> [--resptimeout=<timeout>] [--sotimeout=<timeout>] [--warning=<time>] [--critical=<time>]";
                helpString = helpString + "\n\n";
                helpString = helpString + "Arguments:";
                helpString = helpString + "\n\n";
                helpString = helpString + "--filename=<text file name>:  the name of the text file that will be created. Mandatory argument.";
                helpString = helpString + "\n\n";
                helpString = helpString + "--remoteshare=<share smb url>:  path of remote share. You have to specify the smb url of the share. Mandatory argument. NB: you have to insert a slash at the end of the path.";
                helpString = helpString + "\n\n";
                helpString = helpString + "--username=<username>:  username for connection. Mandatory argument.";
                helpString = helpString + "\n\n";
                helpString = helpString + "--password=<password>:  password of the user. Mandatory argument.";
                helpString = helpString + "\n\n";
                helpString = helpString + "--domain=<user domain>:  domain of the user. Mandatory argument.";
                helpString = helpString + "\n\n";
                helpString = helpString + "--resptimeout=<timeout>:  The time period in milliseconds that the client will wait for a response to a request from the server. Optional argument. Default timeout is 30 seconds.";
                helpString = helpString + "\n\n";
                helpString = helpString + "--sotimeout=<timeout>:  To prevent the client from holding server resources unnecessarily, sockets are closed after this time period if there is no activity. Optional argument. Default timeout is 35 seconds.";
                helpString = helpString + "\n\n";
                helpString = helpString + "--warning=<time>:  To set the warning value (in seconds) for the transfer time. Optional argument. Default value is 2 seconds.";
                helpString = helpString + "\n\n";
                helpString = helpString + "--critical=<time>:  To set the critical value (in seconds) for the transfer time. Optional argument. Default value is 5 seconds.";
                helpString = helpString + "\n\n";
                helpString = helpString + "\n\n";
                helpString = helpString + "Examples:";
                helpString = helpString + "\n\n";
                helpString = helpString + "java -jar check_share.jar --filename=nagios_check_share.txt --remoteshare=smb://dosv012g.domain.local/share01/ --username=dom0301 --password=P455w0rd! --domain=domain --respTimeout=10000 --soTimeout=15000 --warning=2.5 --critical=5.0";
                System.out.println(helpString);
                System.exit(3); //exit code 3 = unknown
            }

	}
        catch (Exception e)
        {
            //print the critical message with no performance data
            System.out.println("CRITICAL: " + e.getMessage() + "|time=s;;;;");
            System.exit(2); //exit code 2 = critical
	}



    }
}
